
stages:
  - images
  - test

default:
  image: "${CI_REGISTRY_IMAGE}:latest"
  tags:
    - gitlab-org

.test-base:
  stage: test
  before_script:
    - gem install bundler --no-document
    - bundle config set clean 'true'
    - bundle config set path 'vendor/bundle'
    - bundle config set with 'test'
    - bundle config set jobs '10'
    - bundle config set retry '3'
    - bundle install --quiet
    - bundle check
    - date

rubocop:
  extends: .test-base
  stage: test
  script:
    - bundle exec rubocop
    - date

rspec:
  extends: .test-base
  stage: test
  script:
    - bundle exec rspec
    - date

.docker_image_template:
  image: docker:19.03.12
  tags:
    - gitlab-org-docker
  services:
    - docker:19.03.12-dind
  retry: 2
  variables:
    DOCKER_TLS_CERTDIR: ""
    IMAGE: ${CI_REGISTRY_IMAGE}

docker_image_build:
  extends: .docker_image_template
  stage: images
  script:
    - export ci_image_tag=${CI_COMMIT_TAG:-$CI_COMMIT_SHORT_SHA}
    - echo ${CI_JOB_TOKEN} | docker login --password-stdin -u $CI_REGISTRY_USER $CI_REGISTRY
    - docker build -t ${IMAGE}:$ci_image_tag -t ${IMAGE}:latest .
    - docker push ${IMAGE}:latest
    - docker push ${IMAGE}:$ci_image_tag
  only:
    - tags
  except:
    - schedules

docker_image_test:
  extends: .docker_image_template
  stage: test
  script:
    - |
      echo "CI_REGISTRY_USER: ${CI_REGISTRY_USER}"
      echo "CI_REGISTRY: ${CI_REGISTRY}"
      echo "CI_JOB_TOKEN: ${CI_JOB_TOKEN}"
      echo "CI_REGISTRY_IMAGE: ${CI_REGISTRY_IMAGE}"
    - docker build .
  only:
    changes:
      - Dockerfile
    refs:
      - merge_requests
      - tags
  except:
    - schedules
